{ Memory
 (C) 2005-2012, Andreas Berg. All Rights Reserved. }
unit _mem;

interface

uses
 _common;

var
 hdrMem            : array[0..30] of TAsmValue;

 MemData           : array of TAsmValue;
 MemLength         : TDefValue;

 MemReplacePos     : TDefValue;

procedure InitMemData;
procedure AddMemValue(val: TAsmValue);

procedure FreeMemData;

implementation

procedure InitMemData;
var
 i                 : integer;
begin
   SetLength(MemData, 1);
   MemLength:= 0;
   MemReplacePos:= -1;
   for i:= 0 to 30 do hdrMem[i]:= 0;
end;

procedure AddMemValue(val: TAsmValue);
begin
   if MemReplacePos = -1 then begin
      SetLength(MemData, MemLength + 1);
      MemData[MemLength]:= val;
      Inc(MemLength);
   end else begin
      MemData[MemReplacePos]:= val;
      Inc(MemReplacePos);
   end;
end;



procedure FreeMemData;
begin
   { To Do: Clear all arrays to free memory }
end;

end.
